<template>
  <div v-if="selectedPlugin !== null">
    <h5 class="text-center mb-4 text-second font_size_18">
      <b-icon icon="sliders"></b-icon> {{ selectedPlugin.label }}
    </h5>

    <div v-for="parameter of selectedPlugin.parameters" :key="parameter.label">
      <!--                 ParameterType.Boolean               -->
      <div v-if="parameter.type === ParameterType.Boolean">
        <b-row class="mb-3 font_size_13" align-v="center">
          <b-col cols="12">
            <b-form-checkbox v-model="parameter.value" switch>
              {{ parameter.label }}
            </b-form-checkbox>
          </b-col>
        </b-row>
      </div>
      <!--                 ParameterType.Text               -->
      <div
        v-else-if="parameter.type === ParameterType.Text"
        class="font_size_13"
      >
        <FormTextInput :label="parameter.label" v-model="parameter.value" />
      </div>
      <!--                 ParameterType.Number               -->
      <div
        v-else-if="parameter.type === ParameterType.Number"
        class="font_size_13"
      >
        <FormNumberInput :label="parameter.label" v-model="parameter.value" />
      </div>
      <!--                 ParameterType.Select               -->
      <div v-else-if="parameter.type === ParameterType.Select">
        <b-row class="mb-3 font_size_13" align-v="center">
          <b-col cols="4">
            <label>{{ parameter.label }}</label>
          </b-col>
          <b-col :cols="8">
            <b-form-select
              v-model="parameter.value"
              :options="parameter.choices"
            ></b-form-select>
          </b-col>
        </b-row>
      </div>
      <!--                 ParameterType.Json  ou ParameterType.TextArea              -->
      <div v-else-if="parameter.type === ParameterType.Json || parameter.type === ParameterType.TextArea">
        <FormTextInput :textArea=true :label="parameter.label" v-model="parameter.value" />
      </div>
      <!--                 Other cases               -->
      <div v-else>{{ parameter.label }} : {{ parameter.value }}</div>
    </div>

    <b-row align-v="center" class="mb-2 button-bottom">
      <b-col class="text-center">
        <b-button @click="updatePlugin()" class="w-75 bg_color-second"
          >Valider</b-button
        >
      </b-col>
    </b-row>
  </div>
</template>

<script lang="ts">
import Component from 'vue-class-component';
import FormTextInput from '@/components/shared/FormTextInput.vue';
import FormNumberInput from '@/components/shared/FormNumberInput.vue';
import BaseComponent from '@/components/BaseComponent';
import Plugin from '@/models/plugin/Plugin';
import { ParameterType } from '@/models/plugin/ParameterType';

@Component({
  props: {
    selectedPlugin: Plugin,
  },
  components: {
    FormTextInput,
    FormNumberInput,
  },
})
export default class PluginEditPanel extends BaseComponent {
  static ID = 'PluginEditPanel';

  ParameterType = ParameterType;

  selectedPlugin!: Plugin;

  updatePlugin() {
    console.log('update');
    if (this.selectedPlugin && this.selectedPlugin.isActive) {
      this.selectedPlugin.isActive = false;
      // eslint-disable-next-line prefer-const
      let plugin = this.selectedPlugin;
      setTimeout(() => {
        plugin.isActive = true;
      },
      400);
    }

    this.$emit('updateDone');
  }
}
</script>

<style scoped lang="less">
</style>
